const gulp = require('gulp');
const jisonCli = require('gulp-jison');
const concat = require('gulp-concat');
const addsrc = require('gulp-add-src');
const wrap = require('gulp-wrap');
const babel = require('gulp-babel');
const sourcemaps = require('gulp-sourcemaps');
const es = require('event-stream');

gulp.task('default',()=>{
        const a = gulp.src('./src/smarttype.jison.l')
        .pipe(jisonCli({moduleType:'js'}))
        .pipe(addsrc('./src/lexerObjOverrides.js'))
        .pipe(concat('parser.js'))
        .pipe(wrap('(function () {\n<%= contents %>}.call(this));'));
         
        const b = gulp.src(['./src/simplifier.es6.js','./src/latex.es6.js','./src/func.es6.js'])
        .pipe(concat('tokenOutput.js'))
        .pipe(babel({
            presets: [
                ["env", {
                    "modules": false
                }]
            ]
        }));
        
        const c = es.merge(a,b)
        .pipe(concat('smarttype.js'))
        .pipe(wrap({ src: './src/smarttypeWrap.js.tpl'}))
        .pipe(gulp.dest('./')); 
        return c;
});